Panda3D

Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
CullPlanes Class Reference

This represents the set of clip planes and/or occluders that are definitely in effect for the current node of the CullTraverserData, as well as on all child nodes. More...

`#include "cullPlanes.h"`

Inheritance diagram for CullPlanes:

## Public Member Functions
| CPT (CullPlanes) apply_state(const CullTraverser *trav
| CPT (CullPlanes) do_cull(int &result
| CPT (CullPlanes) remove_occluder(const NodePath &occluder) const
| CPT (CullPlanes) remove_plane(const NodePath &clip_plane) const
| CPT (CullPlanes) xform(const LMatrix4 &mat) const
| CPT (RenderState) &state
bool | is_empty () const
| Returns true if there are no planes listed in the CullPlanes object. More...
void | write (std::ostream &out) const
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object. More...
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise. More...
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack. More...
void | ref () const
| Explicitly increments the reference count. More...
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero. More...
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus. More...
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus. More...
virtual bool | unref () const
| Explicitly decrements the reference count. More...
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one. More...
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object. More...
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object. More...
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)

## Static Public Member Functions
static | CPT (CullPlanes) make_empty()
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
const CullTraverserData const ClipPlaneAttrib const ClipPlaneAttrib const OccluderEffect *node_effect | const
const GeometricBoundingVolume *node_gbv | const
const CullTraverserData * | data
const CullTraverserData const ClipPlaneAttrib * | net_attrib
const CullTraverserData const ClipPlaneAttrib const ClipPlaneAttrib * | off_attrib
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count. More...

## Detailed Description

This represents the set of clip planes and/or occluders that are definitely in effect for the current node of the CullTraverserData, as well as on all child nodes.

Any clip planes and occluders in this list may be safely culled against.

This does not include the clip planes that are in effect now, but might later be turned off by a child node, since we can't safely cull against such clip planes.

The bounding volumes in this object are transformed for each level of the scene graph.

Definition at line 42 of file cullPlanes.h.

## Member Function Documentation

## ◆ is_empty()

bool CullPlanes::is_empty | ( |  | ) | const
| inline

Returns true if there are no planes listed in the CullPlanes object.

Definition at line 50 of file cullPlanes.I.

The documentation for this class was generated from the following files:

- panda/src/pgraph/cullPlanes.h
- panda/src/pgraph/cullPlanes.I